Package ghidra.app.plugin.assembler.sleigh.expr

# Class Next2InstructionValueSolver

java.lang.Object
ghidra.app.plugin.assembler.sleigh.expr.AbstractExpressionSolver<Next2InstructionValue>
ghidra.app.plugin.assembler.sleigh.expr.Next2InstructionValueSolver

public class Next2InstructionValueSolver extends AbstractExpressionSolver<Next2InstructionValue>
"Solves" expressions of `inst_next2`

Works like the constant solver, but takes the value of `inst_next`, which is given by the assembly address and the resulting instruction length.

NOTE: This solver requires backfill, since the value of `inst_next2` is not known until possible prefixes have been considered.

- ## Field Summary

  ### Fields inherited from class ghidra.app.plugin.assembler.sleigh.expr.AbstractExpressionSolver

  `solver`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Next2InstructionValueSolver()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `getInstructionLength(Next2InstructionValue iv)`
  Determines the length of the subconstructor that would be returned had the expression not depended on an undefined symbol.
  `MaskedLong`
  `getValue(Next2InstructionValue iv, Map<String,Long> vals, AssemblyResolvedPatterns cur)`
  Attempt to get a constant value for the expression
  `AssemblyResolution`
  `solve(AbstractAssemblyResolutionFactory<?,?> factory, Next2InstructionValue exp, MaskedLong goal, Map<String,Long> vals, AssemblyResolvedPatterns cur, Set<SolverHint> hints, String description)`
  Attempt to solve an expression for a given value
  `MaskedLong`
  `valueForResolution(Next2InstructionValue exp, Map<String,Long> vals, AssemblyResolvedPatterns rc)`
  Compute the value of the expression given the (possibly-intermediate) resolution

  ### Methods inherited from class ghidra.app.plugin.assembler.sleigh.expr.AbstractExpressionSolver

  `register`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### Next2InstructionValueSolver

    public Next2InstructionValueSolver()

- ## Method Details

  - ### solve

    public AssemblyResolution solve(AbstractAssemblyResolutionFactory<?,?> factory, Next2InstructionValue exp, MaskedLong goal, Map<String,Long> vals, AssemblyResolvedPatterns cur, Set<SolverHint> hints, String description) throws NeedsBackfillException
    Description copied from class: `AbstractExpressionSolver`
    Attempt to solve an expression for a given value
    Specified by:
      `solve` in class `AbstractExpressionSolver<Next2InstructionValue>`
    Parameters:
      `exp` - the expression to solve
      `goal` - the desired value of the expression
      `vals` - values of defined symbols
      `hints` - describes techniques applied by calling solvers
      `description` - the description to give to resolved solutions
    Returns:
      the resolution
    Throws:
      `NeedsBackfillException` - if the expression refers to an undefined symbol

  - ### getValue

    public MaskedLong getValue(Next2InstructionValue iv, Map<String,Long> vals, AssemblyResolvedPatterns cur) throws NeedsBackfillException
    Description copied from class: `AbstractExpressionSolver`
    Attempt to get a constant value for the expression
    Specified by:
      `getValue` in class `AbstractExpressionSolver<Next2InstructionValue>`
    Parameters:
      `iv` - the expression
      `vals` - values of defined symbols
    Returns:
      the constant value, or null if it depends on a variable
    Throws:
      `NeedsBackfillException` - if the expression refers to an undefined symbol

  - ### getInstructionLength

    public int getInstructionLength(Next2InstructionValue iv)
    Description copied from class: `AbstractExpressionSolver`
    Determines the length of the subconstructor that would be returned had the expression not depended on an undefined symbol.

    This is used by the backfilling process to ensure values are written to the correct offset

    Specified by:
      `getInstructionLength` in class `AbstractExpressionSolver<Next2InstructionValue>`
    Parameters:
      `iv` - the expression
    Returns:
      the length of filled in token field(s).

  - ### valueForResolution

    public MaskedLong valueForResolution(Next2InstructionValue exp, Map<String,Long> vals, AssemblyResolvedPatterns rc)
    Description copied from class: `AbstractExpressionSolver`
    Compute the value of the expression given the (possibly-intermediate) resolution
    Specified by:
      `valueForResolution` in class `AbstractExpressionSolver<Next2InstructionValue>`
    Parameters:
      `exp` - the expression to evaluate
      `vals` - values of defined symbols
      `rc` - the resolution on which to evaluate it
    Returns:
      the result